;; Liquid War 6 is a unique multiplayer wargame.
;; Copyright (C)  2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015  Christian Mauduit <ufoot@ufoot.org>
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;
;; Liquid War 6 homepage : http://www.gnu.org/software/liquidwar6/
;; Contact author        : ufoot@ufoot.org

(define lw6-speed-calibrate-local-pilot
  (lambda (pilot)
    (let* (
	   (max-seq (c-lw6pil-get-max-seq pilot))
	   (next-seq (c-lw6pil-get-next-seq pilot (c-lw6sys-get-timestamp)))
	   (pilot-lag (lw6-config-get-number lw6def-pilot-lag))
	   (delta (- next-seq max-seq))
	   )
      (if (< pilot-lag delta)
	  (let (
		(slow-down (inexact->exact (1+ (floor (/ delta 2)))))
		)
	  (begin
	    (c-lw6pil-slow-down pilot slow-down)
	    (lw6-log-info (format #f "slowing down ~a rounds" slow-down))
	    ))))
    ))
